<?
/////////////////////////////////
//BEGIN OF GET BROWSER FUNCTION//
/////////////////////////////////
function GetBrowser()
{
	$agent = $_SERVER['HTTP_USER_AGENT'];
	$browser = "Unknown";
	
	//Opera
	if (eregi("Opera+(\ |\/)+6", $agent)) { $browser = "Opera 6"; }
	if (eregi("Opera+(\ |\/)+7", $agent)) { $browser = "Opera 7"; }
	if (eregi("Opera+(\ |\/)+8", $agent)) { $browser = "Opera 8"; }
	
	//Mozilla
	if (eregi("Gecko", $agent))
	{
		if (eregi("rv:1.6", $agent)) { $browser = "Mozilla 1.6"; }
		if (eregi("rv:1.7", $agent)) { $browser = "Mozilla 1.7"; }
		if (eregi("rv:1.8", $agent)) { $browser = "Mozilla 1.8"; }
	}
	
	//Firefox
	if (eregi("Firefox+(\ |\/)+0.8", $agent)) { $browser = "Firefox 0.8"; }
	if (eregi("Firefox+(\ |\/)+0.9", $agent)) { $browser = "Firefox 0.9"; }
	if (eregi("Firefox+(\ |\/)+0.10", $agent)) { $browser = "Firefox 1.0"; }
	
	//Konqueror
	if (eregi("Konqueror", $agent)) { $browser = "Konqueror"; }
	
	//MSIE
	if (eregi("MSIE", $agent) && !eregi("Firefox", $agent) && !eregi("Gecko", $agent) && !eregi("Opera", $agent))
	{
		if (eregi("MSIE\ 4", $agent)) { $browser = "Internet Explorer 4"; }
		if (eregi("MSIE\ 5", $agent)) { $browser = "Internet Explorer 5"; } 
		if (eregi("MSIE\ 6", $agent)) { $browser = "Internet Explorer 6"; }
	}
	
	//BOTS
	//Googlebot
	if (eregi("Google", $agent)) { $browser = "Google Bot"; }
	
	//Lycos
	if (eregi("lycos+(\ |\/|\_)+spider", $agent)) { $browser = "Lycos Spider (Bot)"; }
	
	//MSIECrawler
	if (eregi("MSIECrawler", $agent)) { $browser = "MSIE Crawler (Bot)"; }
	
	//MSN Bot
	if (eregi("msnbot", $agent)) { $browser = "MSN Bot"; }
	
	//Shell Browsers
	//W3M
	if (eregi("w3m", $agent)) { $browser = "W3M"; }
	
	//wget
	if (eregi("wget", $agent)) { $browser = "WGET"; }
	
	//Lynx
	if (eregi("lynx", $agent)) { $browser = "Lynx"; }

	return $browser;
}
///////////////////////////////
//END OF GET BROWSER FUNCTION//
///////////////////////////////

////////////////////////////
//BEGIN OF GET OS FUNCTION//
////////////////////////////
function GetOS()
{
	$agent = $_SERVER['HTTP_USER_AGENT'];
	$os = "Unknown";
	if (eregi("WinNT", $agent)  || eregi("Windows NT", $agent)) { $os = "Microsoft Windows NT"; }
	if (eregi("NT 5.2", $agent) || eregi("Windows 2003", $agent)) { $os = "Microsoft Windows 2003"; }
	if (eregi("NT 5.1", $agent) || eregi("Windows XP", $agent)) { $os = "Microsoft Windows XP"; }
	if (eregi("NT 5.0", $agent) || eregi("Windows 2000", $agent))  { $os = "Microsoft Windows 2000"; }
	if (eregi("Windows 95", $agent) || eregi("Win95", $agent)) { $os = "Microsoft Windows 95"; }
	if (eregi("Win 9x 4.90", $agent) || eregi("Windows ME", $agent)) { $os = "Microsoft Windows ME"; }
	if (eregi("Win98", $agent) || eregi("Windows 98", $agent)) { $os = "Microsoft Windows 98"; }
	
	if (eregi("Linux", $agent)) { $os = "Linux"; }
	if (eregi("Mac", $agent)) { $os = "Macintosh"; }
	
	return $os;
}
//////////////////////////
//END OF GET OS FUNCTION//
//////////////////////////

//////////////////////////////////
//BEGIN OF GET LANGUAGE FUNCTION//
//////////////////////////////////
function GetLang()
{
	$header = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
	$pos = 100;
	$lang = "Unknow";
	if (eregi("fr", $header) && strpos($header, "fr") < $pos) { $lang = "French"; $pos = strpos($header, "fr"); }
	if (eregi("en", $header) && strpos($header, "en") < $pos) { $lang = "English";  $pos = strpos($header, "en"); }
	if (eregi("de", $header) && strpos($header, "de") < $pos) { $lang = "German";  $pos = strpos($header, "de"); }
	if (eregi("nl", $header) && strpos($header, "nl") < $pos) { $lang = "Dutch"; $pos = strpos($header, "nl"); }
	if (eregi("da", $header) && strpos($header, "da") < $pos) { $lang = "Danish"; $pos = strpos($header, "da"); }
	if (eregi("it", $header) && strpos($header, "it") < $pos) { $lang = "Italy"; $pos = strpos($header, "it"); }
	if (eregi("es", $header) && strpos($header, "es") < $pos) { $lang = "Spanish"; $pos = strpos($header, "es"); }
	if (eregi("hu", $header) && strpos($header, "hu") < $pos) { $lang = "Hungary"; $pos = strpos($header, "hu"); }
	if (eregi("hr", $header) && strpos($header, "hr") < $pos) { $lang = "Croatien"; $pos = strpos($header, "hr"); }
	if (eregi("ro", $header) && strpos($header, "ro") < $pos) { $lang = "Romanian"; $pos = strpos($header, "ro"); }
	if (eregi("pl", $header) && strpos($header, "pl") < $pos) { $lang = "Polish"; $pos = strpos($header, "pl"); }
	if (eregi("pt", $header) && strpos($header, "pt") < $pos) { $lang = "Portuguese"; $pos = strpos($header, "pt"); }
	
	return $lang; 
}
////////////////////////////////
//END OF GET LANGUAGE FUNCTION//
////////////////////////////////

/////////////////////////////////
//BEGIN OF GET COUNTRY FUNCTION//
/////////////////////////////////
function GetCountry()
{
	$country = "Unknown";
	$ip = $_SERVER['REMOTE_ADDR'];
    $countrydb = file(dirname(__FILE__)."/ip-to-country.csv");
    $ip_number = sprintf("%u",ip2long($ip));

    #binary search attempt
    $low = 0;
    $high = count($countrydb) -1;

    $count = 0;
    while($low <= $high) {
        $count++;
        $mid = floor(($low + $high) / 2);  // C floors for you
        $num1 = substr($countrydb[$mid], 1, 10);
        $num2 = substr($countrydb[$mid], 14, 10);
        if($num1 <= $ip_number && $ip_number <= $num2){
            #start at 27 go 2
            #substr($$countrydb[$mid], 27, 2);
            $country = substr($countrydb[$mid], 38, 50);
			$country = str_replace("\"", "", $country);
			if (eregi("ited states", $country)) $country = "United States";
			
            break;
        } else {
            if ($ip_number < $num1) {
                $high = $mid - 1;
            } else {
                $low = $mid + 1;
            }
        }
    }
	
	return $country;
}
///////////////////////////////
//END OF GET COUNTRY FUNCTION//
///////////////////////////////
?>